#include <stdlib.h>
#include <commdlg.h>
#include <windows.h>
#include "resource.h"


#define MAXBARSNUM 50

/*************************************************************************/
/***                                                                   ***/
/**                         Types and variables                         **/
/***                                                                   ***/
/*************************************************************************/
typedef struct tagBAR
{
	int Length;
	COLORREF Color;
} BAR;

typedef struct tagRESULT
{   
	char Name[25];
	float Time;
    int Swaps;
    int Compares;
    BOOL Done;
} RESULT;

HANDLE hAppInst;   
HWND hMainWnd;

/*************************************************************************/
/***                                                                   ***/
/**                         Function prototypes                         **/
/***                                                                   ***/
/*************************************************************************/
BOOL DoClassRegistration( HINSTANCE );
BOOL InitInstance( HANDLE, int );
int FAR PASCAL WinMain( HINSTANCE, HINSTANCE, LPSTR, int );
long FAR PASCAL __export MainWindowProc( HWND, UINT, WPARAM, LPARAM );
LRESULT _export  FAR PASCAL	AboutProc( HWND, UINT, WPARAM, LPARAM );
int GetRandomValue( int, int );
COLORREF SetBarColor();
void SetRandomBarHeights();
void SetSortedBarHeights();
void SetInverseBarHeights();
void InitPrevBarHeights( HWND );
void InitSort( HWND );
void EndSort( HWND );
void DisplayBars( HWND );
void DrawBar( int );
BOOL FAR PASCAL __export ResultsProc( HWND, unsigned, WORD, LONG );
BOOL FAR PASCAL __export ResultProc( HWND, unsigned, WORD, LONG );
void SelectionSort();
void InsertionSort();
void BubbleSort();
void ShellSort();
void CountSort();
void NDSelectionSort();
void NDInsertionSort();
void NDBubbleSort();
void NDShellSort();
void NDCountSort();



